/*
 * $id: ewdic_v1.0.c, wdic(eng-eng) v1.0 2003/12/18
 *
 * ͹̳ο   α׷Դϴ.
 * ͳݻ(http://dict.org)  ͸ ݴϴ.
 * :(s970501@hotmail.com)
 *
 */

#include <stdio.h>
#include <ctype.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <sys/socket.h>

#define VERSION	"v1.0"
#define URL	"dict.org"
#define SURL	"http://www.dict.org/bin/Dict?Form=Dict2&Database=web1913&Query="

void parse_result(int sd)
{
  char c;
  char buf[1024];
  int i = 0;
  int in_tag = 0;	// html tag ۵ǰ   Ÿϴ.
  int in_main = 0;	//  ۵ html   شϴ ͸ main̶մϴ.
  int is_key = 0;	// &lt; &gt; óϱ  ÷Դϴ.
  buf[0]   = 0;

  printf("---------------------------------------\n");
  printf("-          wdic(eng-eng) %s         -\n", VERSION);
  printf("---------------------------------------\n\n");

  //  ѱھ ޾ мմϴ.
  while (recv(sd, &c, 1, 0) != 0) 
  {
    // ignore \r and \n
    if(c == '\r') continue;
    if(c == '\n') {
      if(in_main) printf("\n"); 
      else continue;
    }
    // tag  ڴ  ҹڷ ٲ㼭 óմϴ.
    if(in_tag)
      buf[i++] = (char)tolower((int)c);
    else
      buf[i++] = c;

    buf[i] = 0;
    switch(c)
    {
      case '<': in_tag    = 1;
		i         = 0;
		buf[i++]  = c;
		buf[i]    = 0;
		break;

      case '>':	in_tag    = 0;
		i         = 0;
                if(in_main) { 
	          if (strcmp("<br>", buf) == 0) printf("\n");
 		  else if (strstr(buf, "<center>")!=NULL) { // stop parsing main
		    in_main = 0; }
                  buf[i] = 0;
                  is_key = 0;
                }
                else { // main ۵Ǵ  Ȯմϴ.
		  if(strstr(buf, "<hr>")!=NULL) 
		    in_main = 1; 
                }
		break;
      case '&':	// main &lt; &gt;  ó
		if (in_main && !in_tag) {
		  is_key    = 1;
		  i        = 0;
		  buf[i++] = c;
		  buf[i]   = 0;
		}
		break;

      case ';':	if (in_main && !in_tag) {
		  if (strcmp("&lt;", buf) == 0)
		    printf("<");
		  else if (strcmp("&gt;", buf) == 0)
		    printf(">");
		  is_key = 0;
		  i      = 0;
		}
		break;
      default:	if(in_main && !in_tag && !is_key)
	 	  printf("%c", c);
		break;
    }
    continue;
  }

  printf("\n");
  printf("-----------------------------------------------------------------------\n");
  printf("- wdic(eng-eng) is made by z9To5o!(s970501@hotmail.com) - 18 Dec 2003 -\n");
  printf("-----------------------------------------------------------------------\n");
}

int submit(char *str)
{
	int sd;
	struct hostent *he;	
	struct sockaddr_in sai;
	char buf[1024];

	sd = socket(AF_INET, SOCK_STREAM, 0);
	if (sd < 0)
	{
		printf("Cannot make a socket.\n");
		return -1;
	}  

	he = gethostbyname(URL);
	bzero((void *)&sai, sizeof(sai));
	sai.sin_family      = AF_INET;
	sai.sin_port        = htons(80);
	sai.sin_addr.s_addr = ((struct in_addr *)(he->h_addr))->s_addr;

	if (connect(sd, (void *)&sai, sizeof(sai)) < 0)
	{
		printf("Cannot connect.\n");
		close(sd);
		return -1;
	}
        
	// Ʈ ã ܾ ϴ.
	sprintf(buf, "GET %s%s\n", SURL, str);
	send(sd, buf, strlen(buf), 0);

	//   ִ html  ޾ мմϴ.
	parse_result(sd);

	close(sd);

	return 0;
}

int main(int argc, char *argv[])
{
	if (argc < 2)
	{
		printf("Usage : wdic word_to_find\n");
		return -1;
	}

	submit(argv[1]);

	return 0;
}

